version: '3.9'

services:

  symfony:
    container_name: symfony_certification
    build:
      context: 'docker/dev/symfony'
      dockerfile: 'Dockerfile'
      args: 
        USER_ID: ${USER_ID}
        GROUP_ID: ${GROUP_ID}
        GIT_EMAIL: ${USER_ID}
        GIT_NAME: ${GROUP_ID}
    labels:
      - "traefik.enable=true"
      - "traefik.http.routers.symfony_certification_insecure.rule=Host(`local.symfony-certification.fr`)"
      - "traefik.http.routers.symfony_certification_insecure.entrypoints=web"
      - "traefik.http.routers.symfony_certification_secure.rule=Host(`local.symfony-certification.fr`)"
      - "traefik.http.routers.symfony_certification_secure.entrypoints=websecure"
      - "traefik.http.routers.symfony_certification_secure.tls.certresolver=myresolver"
      - "traefik.docker.network=traefik_network"
    networks:
      - traefik_network
      - mysql_network
      - mailhog_network
    restart: always
    volumes:
      - &app_volume './symfony:/var/www/html'
      - './logs/symfony:/var/logs'
    working_dir: &app_working_dir '/var/www/html'

  node:
    container_name: symfony_certification_node
    build:
      context: docker/dev/node
      dockerfile: './Dockerfile'
    # keep up container
    tty: true
    depends_on:
      - symfony
    restart: always
    volumes:
      - *app_volume
      - './logs/cron:/var/logs/cron'
    working_dir: *app_working_dir

  caddy:
    container_name: symfony_certification_mercure
    image: dunglas/mercure
    restart: always
    environment:
      # Uncomment the following line to disable HTTPS
      SERVER_NAME: ':80'
      MERCURE_PUBLISHER_JWT_KEY: ${MERCURE_PUBLISHER_JWT_KEY}
      MERCURE_SUBSCRIBER_JWT_KEY: ${MERCURE_SUBSCRIBER_JWT_KEY}
      MERCURE_EXTRA_DIRECTIVES: |
        cors_origins *
        anonymous
        debug
    # Uncomment the following line to enable the development mode
    command: /usr/bin/caddy run --config /etc/caddy/Caddyfile.dev
    labels:
      - "traefik.enable=true"
      - "traefik.http.routers.mercure_symfony_certification_insecure.rule=Host(`local.mercure.symfony-certification.fr`)"
      - "traefik.http.routers.mercure_symfony_certification_insecure.entrypoints=web"
      - "traefik.http.routers.mercure_symfony_certification_secure.rule=Host(`local.mercure.symfony-certification.fr`)"
      - "traefik.http.routers.mercure_symfony_certification_secure.entrypoints=websecure"
      - "traefik.http.routers.mercure_symfony_certification_secure.tls.certresolver=myresolver"
      - "traefik.docker.network=traefik_network"
    volumes:
      - caddy_data:/data
      - caddy_config:/config
    networks:
      - traefik_network

volumes:
  caddy_data:
  caddy_config:

networks:
  traefik_network:
    external: true
  mysql_network:
    external: true
  mailhog_network:
    external: true
